<template>
    <div>
        <div class="loading" v-if="loading">
            <p id="loadd">LOADING...</p>
        </div>
        <div id="modalCentre" class="modal">
            <div class="modal-content">
                <h3>Selecciona el centre</h3>
                <div>
                    <label id="clientL">Client:</label>
                    <input list="clientsL" id="clients" style="text-transform:uppercase" name="clients" v-on:click="deleteValue('clients')" v-on:input="getCentres()" required >
                    <datalist id="clientsL"></datalist>
                </div>
                <div>
                    <label id="centreL">Centre:</label>
                    <input list="centresL" id="centres" name="centres" style="text-transform:uppercase" v-on:click="deleteValue('centres')" disabled required >
                    <datalist id="centresL"></datalist>
                </div>
                <button class="btn btn-primary btn-v" id="btn-validar" type="submit" v-on:click="tancarModal()">
                    <span class="glyphicon glyphicon-plus"></span> Validar
                </button>
            </div>
        </div>
        <!-- The Modal -->
        <div id="myModal" class="modal">

            <!-- Modal content -->
            <div class="modal-content">
                <button class="btn btn-primary" type="submit" v-on:click="obrirModal('tancar')">
                    <span class="close">&times;</span>
                </button>
                <p>Some text in the Modal..</p>
            </div>

        </div>
        <div id="item-P">
            <label id="dataL">Dia:</label>
            <input type="date" class="dataS" id="dataDia" v-model="dataR" v-on:input="getData()" required>
        </div>
        <div>
            <label id="clientL">Client: {{ clientE }}</label>
        </div>
        <div>
            <label id="centreL">Centre: {{ centreE }}</label>
        </div>
        <div class="container">
            <div class="card mostrarTasca">
                <div class="card-header">Afegir tasca</div>
                <div class="card-body">
                    <table id="tTasques">
                        <tr>
                            <td class="campT">
                                <b>Nom del treballador/a</b>
                            </td>

                            <td class="campT">
                                <b>Tasca assignada</b>
                            </td>

                            <td class="campT">
                                <b>Temps tardat</b>
                            </td>

                            <td class="campT">
                                <b>Unitats</b>
                            </td>

                            <td class="campT">
                                <b>Afegir tasques</b>
                            </td>
                        </tr>
                        <datalist id="tasquesTaula"></datalist>
                        <tr v-for="treballador in treballadorsTaula" v-bind:key="treballador.id">
                            <td class="campT" v-text="treballador.treballador_id"></td>
                            <td class="campT">
                                <input list="tasquesTaula" id="tasquesSTaula" name="tasques" v-on:click="deleteValue('tasquess')" required>
                            </td>
                            <td class="campT" v-text="treballador.minInvert"></td>
                            <td class="campT"></td>
                            <td class="campT">
                                <button class="btn btn-primary" id="myBtn" type="submit" v-on:click="obrirModal('obrir')">
                                    <span class="glyphicon glyphicon-plus"></span>
                                </button>
                            </td>
                        </tr>
                    </table>
                    <button class="btn btn-primary btn-v" id="btn-validar" type="submit" v-on:click="validarConceptes()">
                        <span class="glyphicon glyphicon-plus"></span> Validar
                    </button>
                </div>
            </div>
            <!--div class="card afegirTasca">
                <div class="card-header">Afegir tasca</div>
                <div class="card-body">
                    <div class="dada" id="primer">
                        <label>Tasques</label>
                        <input list="tasquesL" id="tasques" name="tasques" v-on:click="deleteValue('tasques')" disabled required>
                        <datalist id="tasquesL"></datalist>
                        <div class="error" id="tasquesE">
                            <p>Aquest camp és obligatori</p>
                        </div>
                    </div>
                    <div class="dada">
                        <label for>Treballador</label>
                        <input list="treballadorsL" id="treballadors" name="treballadors" required>
                        <datalist id="treballadorsL"></datalist>
                        <div class="error" id="treballadorE">
                            <p>Aquest camp és obligatori</p>
                        </div>
                    </div>
                    <div class="dada">
                        <label for>Unitats</label>
                        <input type="number" id="unitats" required>
                        <div class="error" id="unitatsE">
                            <p>Aquest camp és obligatori</p>
                        </div>
                    </div>
                    <div class="dada">
                        <label>Temps teòric unitari:</label>
                        <input type="time" id="tempsTeoricUnitari" required>
                    </div>
                    <div class="dada">
                        <label>Temps teòric total:</label>
                        <input type="time" id="tempsTeoricTotal" required>
                        <div class="error" id="tempsTeoricTotalE">
                            <p>Aquest camp és obligatori</p>
                        </div>
                    </div>
                    <div class="dada">
                        <label>Temps real total:</label>
                        <input type="time" id="tempsRealTotal" required>
                    </div>
                    <div class="dada">
                        <button class="btn btn-success btn-guardar" id="btn-afegir" type="submit" v-on:click="guardarD()">
                            <span class="glyphicon glyphicon-plus"></span> Afegir tasca
                        </button>
                    </div>
                </div>
            </div-->
        </div>
    </div>
</template>

<script>
export default {
    props: ["user", "rutaaction", "ruta"],
    mounted() {
        console.log("Component mounted.");
    },
    data: function() {
        return {
            //Id centre i client guardats a la bbdd
            centreClientG: null,
            //variable que controla quan disparar el loading
            loading: false,
            //Llistat clients obtinguts per l'API
            clientsL: [],
            //Llistat centres obtinguts per l'API
            clientsL: [],
            //Variable mostra el nom del centre en afegir les tasques
            centreE: null,
            //Variable mostra el nom del client en afegir les tasques
            clientE: null,
            //Variable que guarda la data seleccionada, en cas de ser null serà la data d'avui
            dataR: null,
            //Llistat de totes les tasques guardades a la bbdd
            totesTasques: [],
            //Llistat de les tasques assignades al centre
            tasquesC: null,
            //Llistar tots els treballadors
            treballadorsT: [],
            //Centre by id
            centreI: [],
            //Client by id
            clientI: [],
            //Treballadorsd que han fitchat avui
            treballadorsF: [],
            //Tots els treballadors
            treballadorN: null,
            //Llistat concepte assignats al centre
            tasquesC: [],
            //Objecte que conte la hora d'inici i final del treballador + id
            horariFitxar: null,
            //Temps que ha estat treballanat cada treballador
            horesFetes: null,
            //LListat dels treballadors que han fitxar per entrar i sortir de la data corresponent.
            treballadorsTaula: [],
        };
    },
    methods: {
        getClients() {
            var clientsLL = document.getElementById("clientsL");
            var text = "";
            axios.get(this.ruta + "/api/clientsL").then(response => {
                this.clientsL = response.data;
                for (let i = 0; i < this.clientsL.length; i++) {
                    text += '<option value="' + this.clientsL[i].nomClient + '">';
                }
                clientsLL.innerHTML = text;
                text = "";
            });
        },
        getCentres() {
            var client = document.getElementById("clients").value;
            var centresLL = document.getElementById("centresL");
            document.getElementById("centres").disabled = false;
            var text = "";
            var sortir = false;
            var i = 0;
            while (i < this.clientsL.length && sortir == false) {
                if (this.clientsL[i].nomClient == client) {
                    sortir = true;
                } else {
                    i++;
                }
            }
            if (sortir == false) {
                
            } else {
                this.idClient = this.clientsL[i].id;
                axios
                .get(this.ruta + "/api/centresbyidclient/" + this.clientsL[i].id)
                .then(response => {
                    this.centresL = response.data;
                    for (let i = 0; i < this.centresL.length; i++) {
                        text += '<option value="' + this.centresL[i].nomCentre + '">';
                    }
                    centresLL.innerHTML = text;
                    text = "";
                })
                .finally(() => (this.loading = false));
            }
        },
        tancarModal(){
            var client = document.getElementById("clients");
            var centre = document.getElementById("centres");
            var centre_id;
            var client_id;
            var sortir = false;
            var i = 0;
            var j = 0;

            while(j < this.clientsL.length && sortir == false){
                if(client.value == this.clientsL[j].nomClient){
                    sortir = true;
                    client_id = this.clientsL[j].id;
                }else{
                    j++;
                }
            }
            sortir = false;
            while(i < this.centresL.length && sortir == false){
                if(centre.value == this.centresL[i].nomCentre){
                    sortir = true;
                    centre_id = this.centresL[i].id;
                }else{
                    i++;
                }
            }
            if(sortir == true){
                axios
                .post(this.ruta + "/api/guardarcentreclient", {
                    user_id: this.user,
                    client_id: client_id,
                    centre_id: centre_id
                })
                .then(response =>{
                    
                });
                document.getElementById("modalCentre").style.display = "none";
                this.centreE = centre.value;
                this.clientE = client.value;
                this.getData();
                this.getTreballadors();
            }
        },
        deleteValue($inputC) {
            if($inputC == 'tasques'){
                document.getElementById($inputC).value = "";
            }else if($inputC == 'tasquess'){
                document.getElementById($inputC).value = "";
            }else if($inputC == 'clients'){
                document.getElementById($inputC).value = "";
                document.getElementById('centresL').innerHTML = "";
                document.getElementById('centres').value = "";
                document.getElementById('centres').disabled = true;
            }else if($inputC == 'centres'){
                document.getElementById($inputC).value = "";
                document.getElementById('tasquesL').innerHTML = "";
                document.getElementById("tasques").value = "";
                document.getElementById("tasques").disabled = true;
            }
        },
        getData() {
            //document.getElementById("tempsTeoricUnitari").value = "00:00";
            //document.getElementById("tempsTeoricTotal").value = "00:00";
            //document.getElementById("tempsRealTotal").value = "00:00";
            axios.get()
            this.getDataDia();
            this.getLlistar();
        },
        getDataDia() {
            var dataA = this.dataR;
            if (dataA == "" || dataA == null) {
                var d = new Date();
                var curr_date = d.getDate();
                var curr_month = d.getMonth() + 1;
                var curr_year = d.getFullYear();
                if (curr_month < 10) {
                    curr_month = "0" + curr_month;
                }
                if (curr_date < 10) {
                    curr_date = "0" + curr_date;
                }
                dataA = curr_year + "-" + curr_month + "-" + curr_date;
                this.dataR = dataA;
            }
        },
        getLlistar() {
            this.llistarTreballadorsF();
            this.getTasques();
        },
        getTasques() {
            //var tasquesL = document.getElementById("tasquesL");
            var tasquesTaula = document.getElementById("tasquesTaula");
            var sortir = false;
            var j = 0;
            var text = "";
            //document.getElementById("tasques").disabled = false;
            
            axios
            .get(this.ruta + '/api/conceptescentre/' + this.centreClientG.client_id + '-' + this.centreClientG.centre_id)
            .then(response => {
                this.tasquesC = response.data;
                axios
                .get(this.ruta + '/api/tasques')
                .then(response => {
                    this.tasquesT = response.data;
                    for (let i = 0; i < this.tasquesC.length; i++) {
                        while(j < this.tasquesT.length && sortir == false){
                            if(this.tasquesC[i].concepte_id == this.tasquesT[j].id){
                                sortir = true;
                            }else{
                                j++;
                            }
                        }

                        if(sortir == true){
                            text += '<option value="' + this.tasquesT[j].nomTasca + '">';
                        }
                        j = 0;
                        sortir = false;
                    }
                    //tasquesL.innerHTML = text;
                    tasquesTaula.innerHTML = text;
                    text = "";
                })
            })
        },
        llistarTreballadorsF() {
            axios
            .get(this.ruta + '/api/treballadorsF/' + this.centreClientG.client_id + '-' + this.centreClientG.centre_id + '-' + this.dataR)
            .then(response => {
                this.treballadorsTaula = response.data;
                axios
                .get(this.ruta + '/api/treballadors')
                .then(response => {
                    this.treballadorsT = response.data;
                    var sortir = false;
                    var j = 0;
                    for (let i = 0; i < this.treballadorsTaula.length; i++) {
                        var $id = this.treballadorsTaula[i].client_id + '-' + this.treballadorsTaula[i].centre_id + '-' + this.treballadorsTaula[i].treballador_id;
                        this.getHorestreballades($id, i);
                        while(j < this.treballadorsT.length && sortir == false){
                            if(this.treballadorsTaula[i].treballador_id == this.treballadorsT[j].id){
                                sortir = true;
                            }else{
                                j++;
                            }
                        }
                        if(sortir == true){
                            this.treballadorsTaula[i].treballador_id = this.treballadorsT[j].nom;
                        }
                        sortir = false;
                        j = 0;
                    }
                }).finally(() => this.loading = false);
            });
        },
        getTreballadors() {
            var treballadorsL = document.getElementById("treballadorsL");
            var text = "";
            axios.get(this.ruta + "/api/treballadors").then(response => {
                this.treballadorsT = response.data;
                for (let i = 0; i < this.treballadorsT.length; i++) {
                    text += '<option value="' + this.treballadorsT[i].nom + '">' + this.treballadorsT[i].cifDni + '</option>';
                }
                treballadorsL.innerHTML = text;
                text = "";
            });
        },
        getHorestreballades($id, i){
            axios
            .get(this.ruta + '/api/obtenirhoresfitxar/' + $id)
            .then(response => {
                this.horariFitxar = response.data;
                var ids = $id.split('-');
                var segonsEntrada = 0;
                var segonsSortida = 0;
                var horesEntrada = this.horariFitxar[1].split(':');
                var horesSortida = this.horariFitxar[2].split(':');
                var diferenciaHores = 0;
                var residu = 0;
                var divisio = 0;
                segonsEntrada = (parseInt(horesEntrada[0]) * 3600) + (parseInt(horesEntrada[1]) * 60) + (parseInt(horesEntrada[2]));
                segonsSortida = (parseInt(horesSortida[0]) * 3600) + (parseInt(horesSortida[1]) * 60) + (parseInt(horesSortida[2]));

                diferenciaHores = segonsSortida - segonsEntrada;
                divisio = diferenciaHores;
                residu = diferenciaHores;

                for (let i = 0; i < 3; i++) {
                    residu = divisio;
                    divisio = divisio / 60;
                    divisio = Math.trunc(divisio);
                    residu = residu % 60
                    if(i == 0){
                        if(residu < 10){
                            this.horesFetes = '0' + residu;
                        }else{
                            this.horesFetes = residu;
                        }
                    }else{
                        if(residu < 10){
                            this.horesFetes = '0' + residu + ':' + this.horesFetes;
                        }else{
                            this.horesFetes = residu + ':' + this.horesFetes;
                        }
                        
                    }
                }

                this.treballadorsTaula[i].minInvert = this.horesFetes;
            });
        },
        obrirModal($obrir){
            var modal = document.getElementById("myModal");
            if($obrir == 'obrir'){
                modal.style.display = "block";
            }else{
                modal.style.display = "none";
            }
        },
    },
    mounted: function() {
        console.log("Component mounted.");
        this.loading = true;
        axios
        .get(this.ruta + '/api/obtenircentreclient/' + this.user)
        .then(response => {
            this.centreClientG = response.data;
            if(typeof(this.centreClientG.centre_id) == 'undefined'){
                document.getElementById("modalCentre").style.display = "block";
                this.getClients();
            }else{
                axios
                .get(this.ruta + '/api/clientbyid/' + this.centreClientG.client_id)
                .then(response => {
                    this.clientI = response.data;
                    this.clientE = this.clientI.nomClient;
                });

                axios
                .get(this.ruta + '/api/centrebyid/' + this.centreClientG.centre_id)
                .then(response => {
                    this.centreI = response.data;
                    this.centreE = this.centreI.nomCentre;
                });
                this.centreE = this.centreClientG[0];
                this.clientE = this.centreClientG[1];
                this.getData();
            }
        });
    }
};
</script>
